# Blobs

This /blobs/ folder contains packages that should *NOT* be built with our build tools.
It already contains the built artifacts so other packages can depend on them by path.

Contents of this folder:
* SystemJS
   * Version 0.19.25

## SystemJS 0.19.25

We are using a custom copy of SystemJS.

The code of SystemJS is in /lib/ folder (as opposed to the usual /src/ folder that you see in all rush built packages).

There are 2 fixes backported to this version that are included in the source code of SystemJS.
Note that all modifications over the original code are commented with `// SPFx -`

* Getting the source code in the Developer tools (in global-eval.js)
* When eval a global script, ensure that the window variables are correctly restored (in global.js)

Additionally, the following things have been removed:
* ES6 modules support
* Conditional imports
* "bundle" configuration

For this, we use dist/system.spfx.js. This file also reports its version as "SystemJS 0.19.25 for SPFx"

The code comes from https://github.com/systemjs/systemjs (tag 0.19.25)

### How to build it
SystemJS builds using the GNU tools, so rush can't build it properly. In order to build it run `npm install` inside the folder, and then run `make build`