# [sp-client](../../../README.md) › Best Practices › Recommended Coding Practices

## Singleton pattern
- Do not export a singleton.
- __Rarely__, if you need a singleton follow this pattern:

```javascript
export default class Singleton {
  private static _instance: Singleton;

  // Leave this unchanged except for the Singleton class
  public static get instance(): Singleton {
  // Lazy initialize the singleton
  if (this._instance === undefined) {
    this._instance = new Singleton();
  }

  return this._instance;
  }
}
```
> Do not rename the `instance` property. We want an identical pattern across singletons.

## Static code
TODO

## Cloning vs assigning objects
TODO