# [sp-client](../../../README.md) › How To › Test The Yeoman Generator

SharePoint Yeoman generator is a Yeoman plugin for use with the SharePoint Framework.
Using this generator, developers can quickly set up a new client-side web part project with sensible defaults and best practices.

It is important that we are not breaking the generator while developing features.
sp-client-master-npm build runs the generator integration test on master branch to make sure the generator is not broken.

To test the generator locally, do the following steps:

1. Do a full npm build in sp-client.

        Rush rebuild --npm

2. Go to sp-generator-test folder

        cd integration-tests\sp-generator-test

3. Run setup.js and wait for it to pause.

        node lib\setup.js

4. When setup pauses, keep the console window open. It will keep on running the private Verdaccio npm repository which has all the published packages from your local sp-client.

5. Go to your home directory, and make a backup of your .npmrc file.

        copy .npmrc backup.npmrc

6. Open a new command window, and run the following commands to install the generator from local Verdaccio repository.

        npm cache clean
        npm config set registry http://localhost:4873/
        npm config set @ms:registry http://localhost:4873/

        npm uninstall -g @microsoft/generator-sharepoint
        npm install -g @microsoft/generator-sharepoint@generatorVersion    /** you can find generator version in spfx-tools/generator-sharepoint/package.json of your repository **/

        /** Note: if you do not provide generator version, you could end up installing whatever is latest on public npm, not the local one. **/

7. Now you can keep working in this command window to use the generator.

        cd yourWebPartFolder
        yo @microsoft/sharepoint

8. When you are done, close the Verdaccio window.

9. Go to your home directory, copy back your old .npmrc file

        copy backup.npmrc .npmrc

10. And clean up cache

        npm cache clean



