# [sp-client](../../../README.md) › How To › Use Internal NPM Feeds

A VSO feed is a container for packages. You consume and publish packages through a particular VSO feed.

We publish internal NPM packages (that are not available from the npmjs.com) to VSO feed for people inside Microsoft to consume. Internal packages generally use the “@ms” scope. Each product group maintains its own feeds. These private feeds act as a caching proxy as well, allowing you to also install both public and internal packages through it.

For everyday development in sp-client, you must use the “odsp-npm” feed, which contains the dependencies for our projects. We also publish the internal packages that we build to this feed once (via the [sp-client-internal-publish](https://onedrive.visualstudio.com/SPPPlat/Build%20Tools%20Team/_build/index?context=allDefinitions&path=%5Csp-client+NPM+Publish&definitionId=872&_a=completed) CI build definition, which runs daily against the master branch). This allows partner teams to consume our packages from their Git repositories.

Before doing an official SPFx release, we publish all the SPFx packages to a special internal feed called “sp-client-prod-npm”. (Published based on a prod branch.) If you want to test a release candidate, you will need to temporarily reconfigure your .npmrc config file to use this feed. You cannot use both feeds simultaneously. (You can either swap your .npmrc file via copy or use a special tool “npmrc” to switch between configurations.)

After you set up a feed, the credentials stored in your npmrc file will expire after a few months. Your “npm install” will report authentication errors, and you will need to redo these steps to update the stored credentials.

# Enabling the “odsp-npm” feed (normal case)

Same as the steps in [SettingUpYourDevBox](../Onboarding/SettingUpYourDevBox.md)

# Enabling the “sp-client-prod-npm” feed (SPFx testing only)

To connect to sp-client-prod-npm:

1. get the auth token. (Skip if you have already had it.)
Go to https://onedrive.visualstudio.com/SPPPlat/_packaging?feed=sp-client-prod-npm&_a=feed, click "Connect to Feed", select "npm" on the left column,
click "Generate npm credentials".

2. replace the .npmrc file at your user's home directory with the following. Make sure to replace the two lines with the authTokens with what has been copied from the previous step.

    ```
    ; Treat this auth token like a password. Do not share it with anyone, including Microsoft support. This token expires on or before 1/1/2018.
    ; begin auth token
    //onedrive.pkgs.visualstudio.com/_packaging/sp-client-prod-npm/npm/registry/:_authToken=tokenXXXXXXX
    //onedrive.pkgs.visualstudio.com/_packaging/sp-client-prod-npm/npm/:_authToken=tokenXXXXXXX
    ; end auth token

    registry=https://onedrive.pkgs.visualstudio.com/_packaging/sp-client-prod-npm/npm/registry/
    always-auth=true
    ```

3. Run the following to verify that your registry is configured correctly (if the version has suffix "pr.number"):

    ```
    npm view @microsoft/generator-sharepoint version
    ```