# [sp-client](../../../README.md) › Onboarding › Support Contacts

## Tools SHIELD

The SPPPlat tools team (Ian/Nick/Pete/Qinwei) provide technical support for build
issues in this repo.  We have a weekly rotation, which designates one person as the
"SHIELD" role, who will investigate issues and route them appropriately.  The current
SHIELD person is listed on [this page](https://aka.ms/spc-ticket).

Before contacting us directly, please follow these steps:

1. Start a thread on the [spchan](mailto:SP-Client%20Help%20and%20News%20&lt;spchan@service.microsoft.com&gt;)
   discussion group
2. If your issue requires an investigation/fix by the SHIELD person, open a ticket:
   [https://aka.ms/spc-ticket](https://aka.ms/spc-ticket)
3. If several hours have passed without a reply, you can contact the SHIELD person directly.


## Discussion Groups

These are the main discussion groups for client-side SharePoint developers:

----

### SP-Client Help and News ( [spchan](mailto:SP-Client%20Help%20and%20News%20&lt;spchan@service.microsoft.com&gt;) )

**Charter:** Help and discussions pertaining to the **sp-client** git repository.

**Audience:** SPPPlat, WEX, SOX, and other teams with projects in this repo

**Sample discussion topics:**
- What does this weird build error mean?
- Why does this TAB test keep failing?
- How do I debug this page?
- [External Package Review](../HowTo/AddAPackageDependency.md): Can we approve the yaml-js package?
- Announcement: We’re doing these things to improve perf!

----

### Web Build Tools Discussion ( [wbt](mailto:Web%20Build%20Tools%20Discussion%20&lt;wbt@service.microsoft.com&gt;) )

**Charter:** Bug reports, feature ideas, and general discussion for the shared client-side
tooling such as:  Rush, gulp-core-build, API Extractor, Evergreen, etc.

**Audience:** People who develop the build tools, repo maintainers who use the tools, and
devs with an interest in tools.

**Sample discussion topics:**
- Hey, I think there’s a bug with the latest release of Rush, could you investigate?
- I'd like to propose a new command-line option for gulp-core-build -- what do you think?
- Could someone help me enable Evergreen for my repo?
- Here’s the agenda for our next v-team meeting!
- Announcement: We’re rolling out TypeScript 3.0

----

### Modern SharePoint Development ( [ModernSharePointDevelopment](mailto:Modern%20SharePoint%20Development&lt;ModernSharePointDevelopment@service.microsoft.com&gt;) )

**Charter:** Cross-team discussions about client-side SharePoint philosophy, strategy, and current events

**Audience:** A broad audience including thought leaders, PMs, and managers.

**Sample discussion topics:**
- Has anyone tried this exciting new test framework?
- Check out this cool plugin for VS Code!
- Why are we still using the Yeoman DOS Prompt, instead of a graphical experience?
- Should SharePoint drop support for Internet Explorer?
- Announcement: SPFx now supports extensions!
- Announcement: Here's what's new in the latest Office UI Fabric React release
