# [sp-client](../../../README.md) › Procedures › SPFx Release Process

# Steps to release SPFX packages to npm #

Make sure the production branch code has been **tested** via internal release on VSO (local workbench, hosted workbench, deployment)
before following the steps to release to npm.

The order is very **important**. It must be followed exactly. We will automate the steps. But for now, you have to do it manually.

1. Locate the **production** branch that you need to publish from.

2. Find out the SPFx lockstep version for that branch

    The information is in common/config/rush/version-policies.json

    The lockstep version for spfxPublic looks like n1.n2.n3-dev.n4 or n1.n2.n3-pr.n4. That means it is currently a prerelease version.
    Prerelease version should only exist on our internal VSO npm feed.

3. Create a branch for version bump based on the chosen prod branch. Name it approprivately to show it is for version bump.

   The version bump is from prerelease to official release, aka from n1.n2.n3-dev.n4 or n1.n2.n3-pr.n4 to n1.n2.n3.
   Make sure the branch is pushed to origin first:

       git push -u origin yourBranchName
       rush version --bump --version-policy spfxPulibc --override-bump patch -b yourBranchName

   Now the changes have been commited to the branch.

4. Create a pullrequest against the prod branch and pass the build and merge **without** a squash.

   There should be two checkins. One is for change log update. The other the version bump.

5. Release the SPFx packages to npm.

    Just run [sp-client-publish-to-npmjs](https://onedrive.visualstudio.com/SPPPlat/_build/index?context=allDefinitions&path=%5Csp-client+NPM+Publish&definitionId=859&_a=completed)

6. Cherry-pick the change log checkin back to master (note: do not cherry-pick the version change checkin).

7. Bump up the master branch version

       rush version --bump -b yourMasterBranchName

8. Update the [SPFx Release History](./SpfxReleaseHistory.md) record
