# [sp-client](../../../README.md) › Reference › Flight Performance Testing

Read this if you're adding a feature under flight and want to measure its performance impact

## What is Performance AB testing?
You flight your feature and measure various metrics with and without flights enabled to analyse impact of the feature.

With performance AB testing, you also collect flight's performance impact.

## How do I onboard my flight for performance?
This is very simple. Assuming you already have flight number (between 0 to 999), follow this steps:

 - Enlist sp-client source code if not already
 - Open PerformanceLogger.ts file under ..\libraries\sp-telemetry\src\Api folder
 - Search for _flightsOptedABTesting array and add your flight number to existing flights
  private static _flightsOptedABTesting: number[] = [ 33 /* WebpartLoadInViewport */...];
 - Check-in changes in PerformanceLogger.ts file after review

Don't forget to revert your changes once flight testing is done.

## When should I use Performance AB testing?
If your answer is yes to anyone, but not limited to:

- Feature will impact server response time?
- Feature will impact server or client cache?
- Feature will impact assembly size?
- Feature will impact application initialization time?
- Feature will improve page load performance?
- Feature might risk performance for some unknown reason?
- Feature is a big change and you need performance sign off?
- Any other reason makes sense to you

## What performance data I can analyze using Performance AB testing?
Using performance AB testing, you can compare any data captured for performance with and without flight.
The main metric is EUPL (End user perceived latency) but you can dig into any other metrics like App Start, Render Time, Server Response, Module loading etc.
Refer [Telemetry](./Telemetry.md) for more details.

## Is there out of the box Dashboard for Performance AB testing of the flight?
Follow this [link](https://jarvis-west.dc.ad.msft.net/dashboard/ODSP_SPPPLATWeb/Performance/Links) for the Dashbaord. Ensure you change default flight parameter value in the URL with the one you are testing.

## Reference
[Telemetry](./Telemetry.md)


