# [sp-client](../../../README.md) › Reference › SPFx Query Parameters

The client side framework system libraries recognize certain URL query
parameters that are used for diagnostic purposes.  These parameters must
not be used by any client-side application or web part.

# Query Parameters

- **reset**: Resets the content of any developer cookies.

  Example: http://www.contoso.com?reset=true

- **select**: Enhances the odata serialization of the page's list item to expose additional select fields.

  Example: http://www.example.com?select=*,FieldName1,FieldName2 exposes all unhidden fields + fieldName1 + fieldName2.

- **expand**: Enhances the odata serialization of the page's list item to expose all of of the fields.

  Example: http://www.example.com?expand=Folder exposes all of the fields of the Folder property

- **moduleLoader**: Overrides the the path for local host debugging of the moduleLoader.

  Example: http://www.example.com/test.aspx?moduleloader=http://localhost:4321/dist/sp-loader.js

- **market**: Overrides the page's locale.

  Example: http://www.example.com/test.aspx?market=en-us

- **buildid**: Overrides the build used to render the page by specifiying an id. May be used with
  **componentids** parameter. If **componentids** is not specified, all components are overridden.

  Examples:
    - http://www.example.com/test.aspx?buildid=sp-client-prod_20160606.004
    - http://www.example.com/test.aspx?buildid=sp-client-prod_20160606.004&componentids=d1d91016-032f-456d-98a4-721247c305e8;eb95c819-ab8f-4689-bd03-0c2d65d47b1f

- **componentids**: Overrides manifests of only the specified components. List of componentIds are comma delimited.
  Must be used with a **buildid** parameter.

  Example: http://www.example.com/test.aspx?buildid=sp-client-prod_20160606.004&componentids=d1d91016-032f-456d-98a4-721247c305e8;eb95c819-ab8f-4689-bd03-0c2d65d47b1f

- **disableSuiteNav**: Prevents the Suite Nav from loading in an application.

  Example: http://www.example.com?disableSuiteNav=true

- **noredir**: Prevents the page from redirecting to a generic SharePopint error page if an error is caught.
  The error reported to the console instead.

  Example: http://www.example.com?noredir=true

- **debugFlights**: Only available for eDog environment. Overrides the flight status of any flights with the feature ID in the comma separated list.

  Example: http://www.example.com?debugFlights=123,789

- **debugKillSwitches**: Only available for eDog environment. Activates the Kill Switches with the Kill Switch Guid in the comma separated list.

  Example: http://www.example.com?debugKillSwitches=8b941903-a8ce-48cb-895e-d6a419ea9198,6c855436-e4de-48a5-ad41-f61a68e672d7


# URL Fragments

- **debugManifests**: Replaces the production manifests with a string representing a manifest.
  See [DebuggingInEdog.md](../Onboarding/DebuggingInEdog.md) for more information.

