// @alpha
class FabricSupport {
  public static readonly datePickerStrings: IDatePickerStrings;
}

// @alpha (undocumented)
interface ICommonNumberFormatterOptions {
  maximumFractionDigits?: 1 | undefined;
  minimumFractionDigits?: 1 | undefined;
  useGrouping?: boolean;
}

// @alpha (undocumented)
interface IDateFormatterOptions {
  date?: IDateTimeLength;
  datetime?: IDateTimeLength;
  raw?: string;
  skeleton?: IDateSkeleton;
  time?: IDateTimeLength;
}

// @alpha (undocumented)
interface IDateParserOptions extends IDateFormatterOptions {
}

// @alpha (undocumented)
interface INumberFormatterOptions extends ICommonNumberFormatterOptions, INumberStyleOptions {
}

// @alpha (undocumented)
interface INumberParserOptions extends INumberStyleOptions {
}

// @alpha (undocumented)
interface INumberStyleOptions {
  style?: 'decimal' | 'percent';
}

// @alpha (undocumented)
interface IRelativeTimeFormatterOptions {
  form?: 'short' | 'narrow' | 'long';
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
interface ISPDateData {
  date: number;
  fullYear: number;
  hours: number;
  milliseconds?: number;
  minutes: number;
  month: number;
  seconds: number;
  timezoneOffset?: number;
}

// @alpha
class LocaleFormat {
  // @beta
  public static formatDate(value: Date, options?: IDateFormatterOptions): string;
  public static formatNumber(value: number, options?: INumberFormatterOptions): string;
  public static formatRelativeTime(value: number, unit: string, options?: IRelativeTimeFormatterOptions): string;
  public static formatRelativeTimeApproximate(value: Date, options?: IRelativeTimeFormatterOptions): string;
  public static parseDate(value: string, options?: IDateParserOptions): Date;
  public static parseNumber(value: string, options?: INumberParserOptions): number;
}

// @alpha
class SPDate implements ISPDateData {
  constructor(data: ISPDateData);
  public convertFromUTC(toTimezone: SPTimeZone): SPDate;
  public convertToUTC(fromTimezone: SPTimeZone): SPDate;
  public readonly date: number;
  public readonly fullYear: number;
  public readonly hours: number;
  // (undocumented)
  public isSame(inputDate: SPDate): boolean;
  public readonly milliseconds: number;
  public readonly minutes: number;
  public readonly month: number;
  public readonly seconds: number;
  public readonly timezoneOffset: number;
}

// WARNING: Unsupported export: IDateSkeleton
// WARNING: Unsupported export: IDateTimeLength
