// @alpha
class Canvas {
  constructor(container: HTMLElement,
      canvasOptions: ICanvasOptions);
  // (undocumented)
  public readonly count: number;
  public displayMode: DisplayMode;
  public dispose(): void;
  public fetchWebparts(force?: boolean): Promise<void>;
  public openToolbox(row: number): boolean;
  public readonly previewImageUrl: string;
  public render(displayMode: DisplayMode, serializedCanvas?: string): void;
  @autobind public serialize(toJson?: boolean): string;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
enum CanvasControlType {
  FullWidth = 9,
  OneColumn = 10,
  OneThirdColumnLeft = 8,
  OneThirdColumnRight = 7,
  RTE = 4,
  ThreeColumns = 6,
  TwoColumns = 5,
  WebPartZone = 3
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// WARNING: The type "CanvasControlComponent" needs to be exported by the package (e.g. added to index.ts)
// @internal
interface ICanvasControl extends React.Props<CanvasControlComponent> {
  addedFromPersistedData?: boolean;
  controlType: CanvasControlType;
  displayMode: DisplayMode;
  id: string;
  onChange?: () => void;
  position: IControlPosition;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
interface ICanvasOptions {
  // (undocumented)
  a11yManagerId?: string;
  // (undocumented)
  handleCanvasChanged?: () => void;
  // (undocumented)
  handleViewportRendered?: (loadTimeMS: number) => void;
  // (undocumented)
  mode: DisplayMode;
  // (undocumented)
  scrollThreshold?: number;
  // (undocumented)
  serializedCanvasContent?: string;
  // (undocumented)
  serviceScope: ServiceScope;
  // (undocumented)
  shouldCenterAlign?: boolean;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
interface ISPRteProps extends IBaseRteProps, ICanvasControl {
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
interface IWebPartZoneProps extends ICanvasControl {
  webPartData: IWebPartData;
  webPartId: string;
  webPartManifest: IClientSideWebPartManifest<any>;
}

// WARNING: The type "IToolbarButtonProps" needs to be exported by the package (e.g. added to index.ts)
// @alpha
class ToolbarButton extends React.Component<IToolbarButtonProps, {}> {
  // WARNING: The type "IToolbarButtonProps" needs to be exported by the package (e.g. added to index.ts)
  constructor(props: IToolbarButtonProps);
  // WARNING: The type "IToolbarButtonProps" needs to be exported by the package (e.g. added to index.ts)
  static defaultProps: IToolbarButtonProps;
  // WARNING: The type "IToolbarButtonProps" needs to be exported by the package (e.g. added to index.ts)
  public render(): React.ReactElement<IToolbarButtonProps>;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// WARNING: The type "IWebPartRteProps" needs to be exported by the package (e.g. added to index.ts)
// WARNING: The type "IWebPartRteState" needs to be exported by the package (e.g. added to index.ts)
// @internal
class WebPartRte extends BaseRte<IWebPartRteProps, IWebPartRteState> {
  // WARNING: The type "IWebPartRteProps" needs to be exported by the package (e.g. added to index.ts)
  constructor(props: IWebPartRteProps);
  // WARNING: The type "IRichTextEditor" needs to be exported by the package (e.g. added to index.ts)
  // (undocumented)
  protected _afterEditorCreated(editor: IRichTextEditor): void;
  // WARNING: The type "IRichTextEditor" needs to be exported by the package (e.g. added to index.ts)
  // (undocumented)
  protected _createNewEditor(innerHTML: string, startupFocus?: boolean): Promise<IRichTextEditor>;
  // (undocumented)
  protected _finalizeAction(ariaActionName?: string): void;
  protected _handleKeyDown(evt: KeyboardEvent): void;
  // (undocumented)
  protected _initState(): void;
  // (undocumented)
  public focus(): void;
  // (undocumented)
  protected TAG_NAME: string;
}

// (No packageDescription for this package)
