// @internal
interface _IComponentContextParameters {
  instanceId: string;
  loggingTag: string;
  manifest: IClientSideComponentManifest;
  parentServiceScope: ServiceScope;
}

// @beta
class BaseComponent implements IEventObserver {
  // @internal
  constructor();
  // @internal (undocumented)
  protected _initializeContext(context: BaseComponentContext): void;
  public readonly componentId: string;
  protected context: BaseComponentContext;
  public dispose(): void;
  public readonly instanceId: string;
  public readonly isDisposed: boolean;
  public readonly manifest: IClientSideComponentManifest;
  @virtual protected onDispose(): void;
  // @alpha
  @virtual protected onProvideServices(serviceScope: ServiceScope): void;
}

// @beta
class BaseComponentContext {
  // @internal
  constructor(parameters: IComponentContextParameters);
  public readonly instanceId: string;
  public manifest: IClientSideComponentManifest;
  public readonly pageContext: PageContext;
  public readonly serviceScope: ServiceScope;
}

