// @internal (undocumented)
class _DialogManager {
  @autobind public _abort(dialog: BaseDialog): void;
  @autobind public _close(dialog: BaseDialog): Promise<void>;
  @autobind public _rejectOnOpen(dialog: BaseDialog): void;
  public _showSecondary(dialog: BaseDialog, ownerRequestId: Guid, options?: IDialogShowOptions): Promise<void>;
  public alert(message: string, options?: IAlertOptions): Promise<void>;
  public static readonly instance: DialogManager;
  public readonly isShowingDialog: boolean;
  public prompt(message: string, options?: IPromptOptions): Promise<string>;
  @autobind public show(dialog: BaseDialog, options?: IDialogShowOptions): Promise<void>;
}

// @beta
class BaseDialog {
  constructor(config?: IDialogConfiguration);
  // @internal
  public readonly _configuration: IDialogConfiguration;
  public close(): Promise<void>;
  protected readonly domElement: HTMLElement;
  public readonly isHidden: boolean;
  public readonly isOpen: boolean;
  public readonly isSecondary: boolean;
  @virtual protected onAfterClose(): void;
  @virtual protected onBeforeOpen(): Promise<void>;
  protected abstract render(): void;
  public readonly secondaryDialogProvider: SecondaryDialogProvider | undefined;
  public show(options?: IDialogShowOptions): Promise<void>;
}

// @beta
class Dialog {
  public static alert(message: string, options?: IAlertOptions): Promise<void>;
  public static prompt(message: string, options?: IPromptOptions): Promise<string | undefined>;
}

// @beta
interface IAlertOptions extends IDialogShowOptions {
}

// @beta
interface IDialogConfiguration {
  isBlocking?: boolean;
}

// @beta
interface IDialogShowOptions {
  confirmOpen?: () => boolean;
}

// @beta
interface IPromptOptions extends IDialogShowOptions {
  defaultValue?: string;
}

// @beta
class SecondaryDialogProvider {
  public alert(message: string, options?: IAlertOptions): Promise<void>;
  public prompt(message: string, options?: IPromptOptions): Promise<string>;
  public show(dialog: BaseDialog, options?: IDialogShowOptions): Promise<void>;
}

