// @internal
class _ExtensionManager<TExtension extends BaseExtension<{}>> {
  constructor(serviceScope: ServiceScope, expectedType: Function);
  public createExtension(componentId: string,
      propertiesJson: string | undefined,
      contextCreator: (extensionContextParameters: IExtensionContextParameters) => ExtensionContext): Promise<TExtension>;
  public dispose(): void;
  public waitForInitialization(): Promise<TExtension[]>;
}

// @internal
interface _IExtensionContextParameters extends _IComponentContextParameters {
}

// @public
class BaseExtension<TProperties> extends BaseComponent {
  // @internal
  constructor();
  // @internal (undocumented)
  public _init(context: ExtensionContext, propertiesJson: string | undefined): Promise<void>;
  protected context: ExtensionContext;
  @virtual protected onInit(): Promise<void>;
  protected readonly properties: TProperties;
}

// @public
class ExtensionContext extends BaseComponentContext {
  // @internal
  constructor(parameters: IExtensionContextParameters);
  public readonly graphHttpClient: GraphHttpClient;
  public readonly httpClient: HttpClient;
  public readonly spHttpClient: SPHttpClient;
}

