// @internal
interface _IFieldCustomizerContextParameters {
  // (undocumented)
  field: SPField;
  // (undocumented)
  listView: ListViewAccessor | undefined;
}

// @internal
interface _IListViewCommandSetContextParameters {
  // (undocumented)
  listView: ListViewAccessor;
}

// @public
class BaseFieldCustomizer<TProperties> extends BaseExtension<TProperties> {
  protected context: FieldCustomizerContext;
  // (undocumented)
  @virtual public onDisposeCell(event: IFieldCustomizerCellEventParameters): void;
  // (undocumented)
  @virtual public onRenderCell(event: IFieldCustomizerCellEventParameters): void;
}

// @public
class BaseListViewCommandSet<TProperties> extends BaseExtension<TProperties> {
  // @internal
  constructor();
  public context: ListViewCommandSetContext;
  @virtual public onExecute(event: IListViewCommandSetExecuteEventParameters): void;
  @virtual public onListViewUpdated(event: IListViewCommandSetListViewUpdatedParameters): void;
  public tryGetCommand(id: string): Command;
}

// @public
class ColumnAccessor {
  // @internal
  public constructor();
  public readonly field: SPField;
  public readonly visible: boolean;
}

// @public
class Command {
  public ariaLabel: string | undefined;
  public iconImageUrl: string | undefined;
  public id: string;
  public title: string;
  public visible: boolean;
}

// @public
class FieldCustomizerContext extends ExtensionContext {
  // @internal
  constructor(extensionContextParameters: _IExtensionContextParameters,
      fieldCustomizerContextParameters: IFieldCustomizerContextParameters);
  public readonly field: SPField;
  public tryGetListView(): ListViewAccessor | undefined;
}

// @public
interface IFieldCustomizerCellEventParameters {
  domElement: HTMLDivElement;
  fieldValue: any;
  listItem: ListItemAccessor;
  userData: any;
}

// @public
interface IListViewCommandSetExecuteEventParameters {
  itemId: string;
  selectedRows: ReadonlyArray<RowAccessor>;
}

// @public
interface IListViewCommandSetListViewUpdatedParameters {
  selectedRows: ReadonlyArray<RowAccessor>;
}

// @public
class ListItemAccessor {
  // @internal
  public constructor();
  public readonly fields: ReadonlyArray<SPField>;
  public abstract getValue(field: SPField): any;
  public abstract getValueByName(internalName: string): any;
}

// @public
class ListViewAccessor {
  // @internal
  constructor();
  // @internal
  public static _selectedRowsChangedEventName: string;
  public readonly columns: ReadonlyArray<ColumnAccessor>;
  public readonly selectedRowsChangedEvent: Event<SelectedRowsChangedEventArgs>;
  public abstract tryGetColumnByName(internalName: string): ColumnAccessor | undefined;
}

// @public
class ListViewCommandSetContext extends ExtensionContext {
  // @internal
  constructor(extensionContextParameters: _IExtensionContextParameters,
      listViewCommandSetContextParameters: IListViewCommandSetContextParameters);
  // @internal
  public readonly _commands: ReadonlyArray<Command>;
  public readonly listView: ListViewAccessor;
  public manifest: ICommandSetExtensionManifest;
}

// @public
class RowAccessor extends ListItemAccessor {
  // @internal
  public constructor();
}

// @public
class SelectedRowsChangedEventArgs extends EventArgs {
  public selectedRows: ReadonlyArray<RowAccessor>;
}

