// @internal
interface _IODataPageContextInfo {
  // (undocumented)
  alertsEnabled: boolean;
  // (undocumented)
  allowSilverlightPrompt: boolean;
  // (undocumented)
  blockDownloadExperienceEnabled: boolean;
  // (undocumented)
  cdnPrefix: string;
  // (undocumented)
  CorrelationId: string;
  // (undocumented)
  crossDomainPhotosEnabled: boolean;
  // (undocumented)
  currentCultureName: string;
  // (undocumented)
  currentLanguage: number;
  // (undocumented)
  currentUICultureName: string;
  // (undocumented)
  disableAppViews: boolean;
  // (undocumented)
  disableFlows: boolean;
  // (undocumented)
  env: string;
  // (undocumented)
  ExpFeatures: number[];
  // (undocumented)
  farmLabel: string;
  // (undocumented)
  fid: number;
  // (undocumented)
  groupColor: string;
  // (undocumented)
  groupHasHomepage: boolean;
  // (undocumented)
  groupId: string;
  // (undocumented)
  groupType: string;
  // (undocumented)
  guestsEnabled: boolean;
  // (undocumented)
  hasManageWebPermission: boolean;
  // (undocumented)
  hideSyncButtonOnODB: boolean;
  // (undocumented)
  isAnonymousGuestUser: boolean;
  // (undocumented)
  isAppWeb: boolean;
  // (undocumented)
  isExternalGuestUser: boolean;
  // (undocumented)
  isNoScriptEnabled: boolean;
  // (undocumented)
  isSPO: boolean;
  // (undocumented)
  killSwitches: {
    [ key: string ]: boolean
  }
  // (undocumented)
  layoutsUrl: string;
  // (undocumented)
  listBaseTemplate: number;
  // (undocumented)
  listId: string;
  // (undocumented)
  listPermsMask: IODataBasePermission;
  // (undocumented)
  listTitle: string;
  // (undocumented)
  listUrl: string;
  // (undocumented)
  MenuData: Object;
  // (undocumented)
  navigationInfo: IODataNavigationNodeCollection;
  // (undocumented)
  nid: number;
  // (undocumented)
  openInClient: boolean;
  // (undocumented)
  pageItemId: number;
  // (undocumented)
  pageListId: string;
  // (undocumented)
  pagePermsMask: IODataBasePermission;
  // (undocumented)
  pagePersonalizationScope: number;
  // (undocumented)
  PreviewFeaturesEnabled: boolean;
  // (undocumented)
  RecycleBinItemCount: number;
  // (undocumented)
  serverRequestPath: string;
  // (undocumented)
  serverTime: string;
  // (undocumented)
  showNGSCDialogForSyncOnODB: boolean;
  // (undocumented)
  siteAbsoluteUrl: string;
  // (undocumented)
  siteClassification: string;
  // (undocumented)
  siteClientTag: string;
  // (undocumented)
  siteId: string;
  // (undocumented)
  sitePagesEnabled: boolean;
  // (undocumented)
  siteServerRelativeUrl: string;
  // (undocumented)
  siteSubscriptionId: string;
  // (undocumented)
  systemUserKey: string;
  // (undocumented)
  tenantAppVersion: string;
  // (undocumented)
  themeCacheToken: string;
  // (undocumented)
  themedCssFolderUrl: string;
  // (undocumented)
  themedImageFileNames: string;
  // (undocumented)
  userDisplayName: string;
  // (undocumented)
  userEmail: string;
  // (undocumented)
  userId: number;
  // (undocumented)
  userLoginName: string;
  // (undocumented)
  viewId: string;
  // (undocumented)
  viewOnlyExperienceEnabled: boolean;
  // (undocumented)
  webAbsoluteUrl: string;
  // (undocumented)
  webId: string;
  // (undocumented)
  webLanguage: number;
  // (undocumented)
  webLogoUrl: string;
  // (undocumented)
  webPermMasks: IODataBasePermission;
  // (undocumented)
  webServerRelativeUrl: string;
  // (undocumented)
  webTemplate: string;
  // (undocumented)
  webTitle: string;
  // (undocumented)
  webUIVersion: string;
}

// @public
interface IODataBasePermission {
  // (undocumented)
  High: number;
  // (undocumented)
  Low: number;
}

// @public
interface IODataChangeToken {
  StringValue: string;
}

// @public
interface IODataContextWebInformation {
  FormDigestTimeoutSeconds: number;
  FormDigestValue: string;
  LibraryVersion: string;
  SiteFullUrl: string;
  SupportedSchemaVersions: string[];
  WebFullUrl: string;
}

// @public
interface IODataList {
  BaseTemplate: number;
  Created: string;
  CurrentChangeToken: IODataChangeToken;
  Description: string;
  EntityTypeName: string;
  Hidden: boolean;
  Id: string;
  LastItemDeletedDate: string;
  LastItemModifiedDate: string;
  ListItemEntityTypeFullName: string;
  ParentWebUrl: string;
  TemplateFeatureId: string;
  Title: string;
}

// @public
interface IODataListItem {
  ContentTypeId: {
    StringValue: string;
  }
  // (undocumented)
  ID: number;
  Title: string;
  UniqueId: string;
}

// @public
interface IODataNavigationNode {
  Children?: IODataNavigationNode[];
  Id?: number;
  // (undocumented)
  IsDocLib?: boolean;
  IsExternal?: boolean;
  IsVisible?: boolean;
  Title?: string;
  Url?: string;
}

// @public
interface IODataNavigationNodeCollection {
  quickLaunch: IODataNavigationNode[];
  topNav: IODataNavigationNode[];
}

// @public
interface IODataUser {
  Email: string;
  // (undocumented)
  Id: number;
  IsSiteAdmin: boolean;
  LoginName: string;
  PrincipalType: number;
  Title: string;
  UserId: IODataUserId;
}

// @public
interface IODataUserCustomAction {
  // @beta
  ClientSideComponentId: string;
  // @beta
  ClientSideComponentProperties: string;
  CommandUIExtension: string;
  Description: string;
  Group: string;
  Id: string;
  ImageUrl: string;
  Location: string;
  RegistrationId: string;
  RegistrationType: number;
  Rights: IODataBasePermission;
  Scope: number;
  ScriptBlock: string;
  ScriptSrc: string;
  Sequence: number;
  Title: string;
  Url: string;
  VersionOfUserCustomAction: string;
}

// @public
interface IODataWeb {
  Created?: string;
  CurrentChangeToken?: IODataChangeToken;
  CustomMasterUrl?: string;
  Description?: string;
  Id?: string;
  IsMultilingual?: boolean;
  Language?: number;
  LastItemModifiedDate?: string;
  MasterUrl?: string;
  NoCrawl?: boolean;
  QuickLaunchEnabled?: boolean;
  RecycleBinEnabled?: boolean;
  ServerRelativeUrl?: string;
  SiteLogoUrl?: string;
  Title?: string;
  UIVersion?: number;
  Url?: string;
  WebTemplate?: string;
}

