// @internal
interface _ICultureInfoData {
  // (undocumented)
  currentCultureName: string;
  // (undocumented)
  currentUICultureName: string;
  // (undocumented)
  isRightToLeft: boolean;
}

// @internal
interface _IO365GroupAssociationData {
  id: string;
  type: string;
}

// @internal (undocumented)
interface _ISPFieldData {
  // (undocumented)
  clientSideComponentId: string;
  // (undocumented)
  clientSideComponentProperties: string;
  // (undocumented)
  displayName: string;
  // (undocumented)
  fieldType: string;
  // (undocumented)
  id: string;
  // (undocumented)
  internalName: string;
  // (undocumented)
  isRequired: boolean;
}

// @public
class CultureInfo {
  // @internal
  constructor(data: ICultureInfoData);
  public readonly currentCultureName: string;
  public readonly currentUICultureName: string;
  public readonly isRightToLeft: boolean;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
interface IPageContextData {
  // (undocumented)
  cultureInfo: ICultureInfoData;
  // (undocumented)
  list?: ISPListData;
  // (undocumented)
  listItem?: ISPListItemData;
  // (undocumented)
  site: ISPSiteData;
  // (undocumented)
  user: ISPUserData;
  // (undocumented)
  web: ISPWebData;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
interface ISPListData {
  // (undocumented)
  baseTemplate: number;
  // (undocumented)
  id: string;
  // (undocumented)
  permissions: IODataBasePermission;
  // (undocumented)
  serverRelativeUrl: string;
  // (undocumented)
  title: string;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
interface ISPListItemData {
  // (undocumented)
  id: number;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
interface ISPSiteData {
  // (undocumented)
  absoluteUrl: string;
  // (undocumented)
  cdnPrefix: string;
  // (undocumented)
  classification: string;
  // (undocumented)
  correlationId: string;
  // (undocumented)
  group?: IO365GroupAssociationData;
  // (undocumented)
  id: string;
  // (undocumented)
  isNoScriptEnabled: boolean;
  // (undocumented)
  recycleBinItemCount: number;
  // (undocumented)
  serverRelativeUrl: string;
  // (undocumented)
  serverRequestPath: string;
  // (undocumented)
  sitePagesEnabled: boolean;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
interface ISPSystemTime {
  // (undocumented)
  Day: number;
  // (undocumented)
  DayOfWeek: number;
  // (undocumented)
  Hour: number;
  // (undocumented)
  Milliseconds: number;
  // (undocumented)
  Minute: number;
  // (undocumented)
  Month: number;
  // (undocumented)
  Second: number;
  // (undocumented)
  Year: number;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
interface ISPTimeZoneData {
  // (undocumented)
  daylightDate: ISPSystemTime;
  // (undocumented)
  daylightOffset: number;
  // (undocumented)
  description: string;
  // (undocumented)
  id: number;
  // (undocumented)
  offset: number;
  // (undocumented)
  standardDate: ISPSystemTime;
  // (undocumented)
  standardOffset: number;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
interface ISPUserData {
  // (undocumented)
  displayName: string;
  // (undocumented)
  email: string;
  // (undocumented)
  isAnonymousGuestUser: boolean;
  // (undocumented)
  isExternalGuestUser: boolean;
  // (undocumented)
  loginName: string;
  // (undocumented)
  preferUserTimeZone: boolean;
  // (undocumented)
  timeZoneInfo?: ISPTimeZoneData;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
interface ISPWebData {
  // (undocumented)
  absoluteUrl: string;
  // (undocumented)
  description: string;
  // (undocumented)
  id: string;
  // (undocumented)
  isAppWeb: boolean;
  // (undocumented)
  language: number;
  // (undocumented)
  logoUrl: string;
  // (undocumented)
  permissions: IODataBasePermission;
  // (undocumented)
  serverRelativeUrl: string;
  // (undocumented)
  templateName: string;
  // (undocumented)
  timeZoneInfo?: ISPTimeZoneData;
  // (undocumented)
  title: string;
}

// @alpha
class O365GroupAssociation {
  // @internal
  constructor(data: IO365GroupAssociationData);
  public readonly id: Guid;
  public readonly type: O365GroupAssociationType;
}

// @alpha
enum O365GroupAssociationType {
  // (undocumented)
  Private = 1,
  // (undocumented)
  Public = 2,
  // (undocumented)
  Unknown = 0
}

// @public
class PageContext {
  constructor(serviceScope: ServiceScope);
  public readonly cultureInfo: CultureInfo;
  // WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
  // @internal
  public initialize(options: IPageContextData, legacyPageContext?: any): void;
  public readonly isInitialized: boolean;
  public readonly legacyPageContext: any;
  public readonly list: SPList | undefined;
  public readonly listItem: SPListItem | undefined;
  public static serviceKey: ServiceKey<PageContext>;
  public readonly site: SPSite;
  public readonly user: SPUser;
  public readonly web: SPWeb;
}

// @alpha
class PageManager {
  constructor(serviceScope: ServiceScope);
  public navigateToPage(serverRelativePageUrl: string,
      options?: IPageContextData,
      // tslint:disable-next-line:no-any
      legacyPageContext?: any): Promise<void>;
  // (undocumented)
  public readonly pageContext: PageContext;
  public static serviceKey: ServiceKey<PageManager>;
}

// @alpha
class SharePointPageContextDataProvider {
  constructor(serviceScope: ServiceScope);
  // @internal
  public static _createPageContextData(spPageContextInfo: any): IPageContextData;
  public fetchComponentContextInfo(serverRelativePageUrl: string): Promise<any>;
}

// @beta
class SPField {
  // @internal
  constructor(data: ISPFieldData);
  public readonly clientSideComponentId: Guid | undefined;
  public readonly clientSideComponentProperties: string;
  public readonly displayName: string;
  public readonly fieldType: string;
  public readonly id: Guid;
  public readonly internalName: string;
  public readonly isRequired: boolean;
}

// @public
class SPList {
  // @internal
  constructor(data: ISPListData);
  public readonly id: Guid;
  public readonly permissions: SPPermission;
  public readonly serverRelativeUrl: string;
  public readonly title: string;
}

// @public
class SPListItem {
  // @internal
  constructor(data: ISPListItemData);
  public readonly id: number;
}

// @public
class SPPermission {
  constructor(value: IODataBasePermission);
  public static addAndCustomizePages: SPPermission;
  public static addDelPrivateWebParts: SPPermission;
  public static addListItems: SPPermission;
  public static applyStyleSheets: SPPermission;
  public static applyThemeAndBorder: SPPermission;
  public static approveItems: SPPermission;
  public static browseDirectories: SPPermission;
  public static browserUserInfo: SPPermission;
  public static cancelCheckout: SPPermission;
  public static createAlerts: SPPermission;
  public static createGroups: SPPermission;
  public static createSSCSite: SPPermission;
  public static deleteListItems: SPPermission;
  public static deleteVersions: SPPermission;
  public static editListItems: SPPermission;
  public static editMyUserInfo: SPPermission;
  public static emptyMask: SPPermission;
  public static enumeratePermissions: SPPermission;
  public static fullMask: SPPermission;
  public hasAllPermissions(...requestedPerms: SPPermission[]): boolean;
  public hasAnyPermissions(...requestedPerms: SPPermission[]): boolean;
  public hasPermission(requestedPerm: SPPermission): boolean;
  public static layoutsPage: SPPermission;
  public static manageAlerts: SPPermission;
  public static manageLists: SPPermission;
  public static managePermissions: SPPermission;
  public static managePersonalViews: SPPermission;
  public static manageSubwebs: SPPermission;
  public static manageWeb: SPPermission;
  public static open: SPPermission;
  public static openItems: SPPermission;
  public static updatePersonalWebParts: SPPermission;
  public static useClientIntegration: SPPermission;
  public static useRemoteAPIs: SPPermission;
  public readonly value: IODataBasePermission;
  public static viewFormPages: SPPermission;
  public static viewListItems: SPPermission;
  public static viewPages: SPPermission;
  public static viewUsageData: SPPermission;
  public static viewVersions: SPPermission;
}

// @public
class SPSite {
  // @internal
  constructor(data: ISPSiteData);
  public readonly absoluteUrl: string;
  public readonly cdnPrefix: string;
  public readonly classification: string;
  public readonly correlationId: Guid;
  public readonly group: O365GroupAssociation | undefined;
  public readonly id: Guid;
  public readonly isNoScriptEnabled: boolean;
  public readonly recycleBinItemCount: number;
  public readonly serverRelativeUrl: string;
  public readonly serverRequestPath: string;
  public readonly sitePagesEnabled: boolean;
}

// @alpha
class SPTimeZone {
  constructor(data: ISPTimeZoneData);
  public readonly daylightDate: ISPSystemTime;
  public readonly daylightOffset: number;
  public readonly description: string;
  public readonly id: number;
  public readonly offset: number;
  public readonly standardDate: ISPSystemTime;
  public readonly standardOffset: number;
}

// @public
class SPUser {
  // @internal
  constructor(data: ISPUserData);
  public readonly displayName: string;
  public readonly email: string;
  public readonly isAnonymousGuestUser: boolean;
  public readonly isExternalGuestUser: boolean;
  public readonly loginName: string;
  public readonly preferUserTimeZone: boolean;
  // @alpha
  public readonly timeZoneInfo: SPTimeZone | undefined;
}

// @public
class SPWeb {
  // @internal
  constructor(data: ISPWebData);
  public readonly absoluteUrl: string;
  public readonly description: string;
  public readonly id: Guid;
  public readonly isAppWeb: boolean;
  public readonly language: number;
  public readonly logoUrl: string;
  public readonly permissions: SPPermission;
  public readonly serverRelativeUrl: string;
  public readonly templateName: string;
  // @alpha
  public readonly timeZoneInfo: SPTimeZone | undefined;
  public readonly title: string;
}

