// @internal (undocumented)
class _CircularBuffer<DataType> {
  constructor(size: number);
  // (undocumented)
  public forEach(handle: (value: DataType) => void): void;
  // (undocumented)
  public push(item: DataType): void;
  // (undocumented)
  public removeAll(): void;
}

// @internal
enum _Component {
  // (undocumented)
  Button = 'Button',
  // (undocumented)
  Component = 'Component',
  // (undocumented)
  Extension = 'Extension',
  // (undocumented)
  Header = 'Header',
  // (undocumented)
  NewButton = 'NewButton',
  // (undocumented)
  ScrollBar = 'ScrollBar',
  // (undocumented)
  View = 'View'
}

// @internal
enum _CurrentPage {
  // (undocumented)
  ArticlePage = 'ArticlePage',
  // (undocumented)
  ClassicPage = 'ClassicPage',
  // (undocumented)
  HomePage = 'HomePage',
  // (undocumented)
  ModernPage = 'ModernPage',
  // (undocumented)
  NewsArticlePage = 'NewsArticlePage'
}

// @internal
class _EngagementLogger {
  // @internal
  public static _initialize(logger: IEngagementHandler): void;
  public static log(engagementData: IEngagementData): void;
  public static logEvent(tagName: string, actionName?: string): void;
  public static logEventWithLogEntry(logEntry: ILogEntry): void;
}

// @internal
enum _Feature {
  // (undocumented)
  Canvas = 'Canvas',
  // (undocumented)
  Header = 'Header',
  // (undocumented)
  LeftNav = 'Leftnav',
  // (undocumented)
  News = 'News',
  // (undocumented)
  ScrollBar = 'ScrollBar',
  // (undocumented)
  TopNav = 'TopNav',
  // (undocumented)
  WebPart = 'WebPart'
}

// @internal
interface _IABExperiment {
  IsExperimentOn?: () => boolean;
}

// @internal
interface _IEngagementData {
  component?: Component;
  currentPage?: CurrentPage;
  experiment?: IABExperiment;
  extraData?: IEngagementExtraData;
  feature?: Feature;
  isIntentional?: boolean;
  name: string;
  siteId?: string;
  siteType?: SiteType;
  usageType?: UsageType;
  webId?: string;
}

// @internal
interface _IEngagementExtraData {
  action?: string;
  // (undocumented)
  message?: string;
}

// @internal
interface _IEngagementHandler {
  logData(data: IEngagementData): void;
}

// @internal (undocumented)
interface _ILogEntry {
  logFeature: string;
  logProperties?: {
    [ key: string ]: string
  }
  logType: LogType;
  moduleName: string;
}

// @internal
interface _ILogSource {
  // (undocumented)
  id: string;
}

// @internal
interface _ITelemetrySettings {
  clientSideApplicationId: string;
  correlationId: string;
  currentUICultureName: string;
  enableConsoleLog: boolean;
  environment: string;
  farmLabel: string;
  loginName: string;
  siteId: string;
  siteSubscriptionId: string;
  systemUserKey: string;
  version: string;
  webId: string;
}

// @internal
interface _ITraceHandler {
  log(error: string | Error, eventName?: string, resultCode?: string): void;
  // (undocumented)
  verbose(error: string, eventName?: string): void;
}

// @internal (undocumented)
interface _ITraceLogger {
  // (undocumented)
  logError(source: ILogSource, error: Error, eventName?: string, resultCode?: string): void;
  // (undocumented)
  logErrorWithLogEntry(source: ILogSource, logEntry: ILogEntry,
      eventName?: string, resultCode?: string): void;
  // (undocumented)
  logVerbose(source: ILogSource, message: string, eventName?: string): void;
  // (undocumented)
  logVerboseWithLogEntry(source: ILogSource, logEntry: ILogEntry, eventName?: string): void;
}

// @internal
class _LogEntry implements ILogEntry {
  constructor(moduleName: string,
      logFeature: string = LogFeature.None,
      logType: LogType = LogType.Trace,
      logProperties?: { [key: string]: string });
  // (undocumented)
  public logFeature: string;
  // (undocumented)
  public logProperties: {
    [ key: string ]: string
  }
  // (undocumented)
  public logType: LogType;
  // (undocumented)
  public moduleName: string;
  public toString(): string;
}

// @internal
class _LogEvent {
  constructor(source: string, data: string | Error, level: LogLevel, serviceScope?: ServiceScope);
  // (undocumented)
  public readonly error: Error;
  // (undocumented)
  public readonly level: LogLevel;
  public static log(source: string, data: string | Error, level: LogLevel, serviceScope?: ServiceScope): LogEvent;
  // (undocumented)
  public readonly message: string;
  // (undocumented)
  public readonly prefix: string;
  // (undocumented)
  public readonly scope: LogSource;
  // (undocumented)
  public readonly source: string;
  // (undocumented)
  public readonly timestamp: number;
  // (undocumented)
  public toString(): string;
}

// @internal
enum _LogLevel {
  // (undocumented)
  Error,
  Info,
  Verbose = 1,
  // (undocumented)
  Warning
}

// @internal
class _LogManager {
  // (undocumented)
  public static addHandler(handler: (e: LogEvent) => void): void;
  // (undocumented)
  public static readonly events: CircularBuffer<LogEvent>;
  // (undocumented)
  public static log(event: LogEvent): void;
  // (undocumented)
  public static removeHandler(handler: (e: LogEvent) => void): void;
  // (undocumented)
  public static reset(): void;
}

// @internal
class _LogSource implements ILogSource {
  constructor(id: string);
  public static create(id: string): LogSource;
  // (undocumented)
  public id: string;
  // (undocumented)
  public isEmpty(): boolean;
}

// @internal
enum _LogType {
  Error = 3,
  Event = 2,
  Trace = 1
}

// @internal
class _PageMetricsLogger {
  public static overwriteScenarioId(scenarioId: string): void;
  public static recordMetric(metricName: string, count: number = 1): void;
  public static reset(scenarioId: string, fullPageLoad: boolean): void;
}

// @internal (preapproved)
class _PerformanceLogger {
}


// @internal (preapproved)
class _QosMonitor {
}


// @internal
enum _SiteType {
  // (undocumented)
  CommSite = 'CommunicationSite',
  // (undocumented)
  Group = 'GroupSite',
  // (undocumented)
  PublishingSite = 'PublishingSite',
  // (undocumented)
  Team = 'TeamSite'
}

// @internal
class _SPTelemetryLogHandler implements ILogHandler {
  // (undocumented)
  public error(source: string, error: Error, scope: ServiceScope): void;
  // (undocumented)
  public info(source: string, message: string, scope: ServiceScope): void;
  // (undocumented)
  public verbose(source: string, message: string, scope: ServiceScope): void;
  // (undocumented)
  public warn(source: string, message: string, scope: ServiceScope): void;
}

// @internal
class _Telemetry {
  public static initialize(workloadName: string,
      settings: ITelemetrySettings): void;
  public static updateSettings(settings: Partial<ITelemetrySettings>): void;
}

// @internal
class _TraceLogger {
  // @internal
  public static _initialize(logger: ITraceHandler): void;
  public static logError(source: ILogSource,
      error: Error,
      eventName?: string,
      resultCode?: string): void;
  // WARNING: The type "ILogErrorData" needs to be exported by the package (e.g. added to index.ts)
  public static logErrorData(data: ILogErrorData): void;
  public static logErrorWithLogEntry(source: ILogSource,
      logEntry: ILogEntry,
      eventName?: string,
      resultCode?: string): void;
  public static logVerbose(source: ILogSource,
      message: string,
      eventName?: string): void;
  // WARNING: The type "ILogVerboseData" needs to be exported by the package (e.g. added to index.ts)
  public static logVerboseData(data: ILogVerboseData): void;
  // (undocumented)
  public static logVerboseWithLogEntry(source: ILogSource,
      logEntry: ILogEntry,
      eventName?: string): void;
  public static shouldWriteToConsole: boolean;
}

// @internal
enum _UsageType {
  // (undocumented)
  Click = 'Click',
  // (undocumented)
  Drag = 'Drag',
  // (undocumented)
  Drop = 'Drop',
  // (undocumented)
  Hover = 'Hover',
  // (undocumented)
  KeyDown = 'KeyDown',
  // (undocumented)
  KeyPress = 'KeyPress',
  // (undocumented)
  Load = 'Load',
  // (undocumented)
  PageLoad = 'PageLoad',
  // (undocumented)
  Render = 'Render',
  // (undocumented)
  RightClick = 'RightClick',
  // (undocumented)
  Scroll = 'Scroll',
  // (undocumented)
  ScrollDown = 'ScrollDown',
  // (undocumented)
  ScrollUp = 'ScrollUp',
  // (undocumented)
  Swipe = 'Swipe',
  // (undocumented)
  Tap = 'Tap'
}

// WARNING: Unsupported export: _logSourceServiceKey
// (No packageDescription for this package)
