// @internal
class _Animations {
  public clear(): void;
  public init(): void;
  public static readonly instance: _Animations;
  public reveal(elem: HTMLElement): void;
  public setScrollableParent(elem: HTMLElement): void;
}

// @internal
interface _IPlaceholderSpinnerState {
  removePlaceholder?: boolean;
  showSpinner: boolean;
}

// @internal
interface _IPropertyPaneChoiceGroupOptionInternal extends IPropertyPaneChoiceGroupOption {
  themableSvg?: JSX.Element;
}

// @internal
class _ScrollEventHandler {
  // (undocumented)
  public static readonly instance: ScrollEventHandler;
  // WARNING: The type "IScrollEventHandler" needs to be exported by the package (e.g. added to index.ts)
  @autobind public register(element: HTMLElement,
      callbackFunction: IScrollEventHandler,
      scrollableParent?: HTMLElement): void;
  public reset(): void;
  // WARNING: The type "IScrollEventHandler" needs to be exported by the package (e.g. added to index.ts)
  public unregister(element: HTMLElement,
      callbackFunction: IScrollEventHandler): void;
}

// WARNING: Unsupported member: propertyPaneRenderedByWebPart
// @public
class BaseClientSideWebPart<TProperties> extends BaseComponent {
  constructor();
  // @internal
  @virtual protected _calculateMinimumHeight(): number | undefined;
  // @internal (undocumented)
  protected _internalGetData(): Promise<void>;
  protected accessibleTitle: string;
  protected readonly canOpenPopupOnRender: boolean;
  protected clearError(): void;
  protected context: WebPartContext;
  protected readonly dataVersion: Version;
  protected readonly description: string;
  protected readonly disableReactivePropertyChanges: boolean;
  protected readonly displayMode: DisplayMode;
  protected readonly domElement: HTMLElement;
  @virtual protected getPropertyPaneConfiguration(): IPropertyPaneConfiguration;
  protected readonly isRenderAsync: boolean;
  @virtual protected onAfterDeserialize(deserializedObject: any, dataVersion: Version): TProperties;
  @virtual protected onAfterPropertyPaneChangesApplied(): void;
  // @alpha
  @virtual protected onAfterResize(newWidth: number): void;
  @virtual protected onBeforeSerialize(): void;
  @virtual protected onDisplayModeChanged(oldDisplayMode: DisplayMode): void;
  @virtual protected onDispose(): void;
  // WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
  // @internal
  protected onEvent < T >(eventName: string, eventObject: IWebPartEvent<T>): void;
  @virtual protected onInit(): Promise<void>;
  @virtual protected onPropertyPaneConfigurationComplete(): void;
  @virtual protected onPropertyPaneConfigurationStart(): void;
  @virtual protected onPropertyPaneFieldChanged(propertyPath: string, oldValue: any, newValue: any): void;
  @virtual protected onPropertyPaneRendered(): void;
  protected previewImageUrl: string | undefined;
  protected readonly properties: TProperties;
  protected readonly propertiesMetadata: IWebPartPropertiesMetadata | undefined;
  protected abstract render(): void;
  protected renderCompleted(): void;
  protected readonly renderedFromPersistedData: boolean;
  protected readonly renderedOnce: boolean;
  protected renderError(error: Error): void;
  protected readonly title: string;
  // @alpha
  protected readonly width: number;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
class BasePropertyPaneControl implements IPropertyPaneControl {
  // (undocumented)
  public abstract _internalDispose(): void;
  // (undocumented)
  public abstract _internalGetPropertyPaneData(): IPropertyPaneData;
  // (undocumented)
  public _internalOnAfterResize(): void;
  // (undocumented)
  public _internalOnConfigurationEvent(configurationEvent: WebPartConfigurationEvent): void;
  // (undocumented)
  public abstract _internalOnPropertyPaneFieldChanged(newPropertyPath: string, newValue: any): void;
  // (undocumented)
  public _internalSerialize(): IWebPartData | undefined;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
class ClientSideWebPartManager {
  public constructor(host: IWebPartHost);
  protected _getWebPartContext(context: IWebPartManagerContext): WebPartContext;
  public dispose(): void;
  public disposeWebparts(instanceId?: string): void;
  public fetchWebPartManifests(): Promise<void>;
  public getWebPartManifests(): IClientSideWebPartManifest<any>[];
  public isPropertyPaneOpen(): boolean;
  public isPropertyPaneRenderedByWebPart(): boolean;
  public loadWebPart(context: IWebPartManagerContext): Promise<void>;
  public notifyWebPartContainerResize(instanceId?: string): void;
  public onWebPartDelete(instanceId: string): void;
  public renderError(domElement: HTMLElement, error: Error): void;
  public serialize(instanceId?: string): Map<string, IWebPartData | undefined>;
  public setDisplayMode(displayMode: DisplayMode, instanceId?: string): void;
  // WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
  // WARNING: The type "IPropertyPaneControl" needs to be exported by the package (e.g. added to index.ts)
  // @internal
  public setPropertyPaneControl(id: string, control: IPropertyPaneControl): void;
  public setPropertyPaneState(instanceId: string,
      propertyPaneState: PropertyPaneState = PropertyPaneState.Default,
      renderedByWebPart?: boolean): void;
  public setWebPartData(webPartData: IWebPartData, instanceId: string): void;
  // (undocumented)
  public tryGeneratePreviewImageUrl(instanceIds?: string[]): string | undefined;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
class ClientSideWebPartManagerFactory {
  // (undocumented)
  public static create(host: IWebPartHost): ClientSideWebPartManager;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
class EventAggregator implements IEventAggregator {
  public raiseEvent < T >(eventName: string, eventObject: IEvent<T>): void;
  public subscribeByEventName < T >(eventName: string, subscriberId: string, callback: IEventCallback<T>): void;
  public subscribeBySourceId < T >(sourceId: string, subscriberId: string, callback: IEventCallback<T>): void;
}

// @public
interface IClientSideWebPartStatusRenderer {
  clearError(domElement: HTMLElement): void;
  clearLoadingIndicator(domElement: Element): void;
  displayLoadingIndicator(domElement: Element, loadingMessage: string, timeout?: number): void;
  renderError(domElement: HTMLElement, error: Error | string): void;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
interface IEvent<T> {
  // (undocumented)
  data?: T;
  // (undocumented)
  sourceId: string;
  // (undocumented)
  targetId: string;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
interface IEventAggregator {
  raiseEvent < T >(eventName: string, eventObject: IEvent<T>): void;
  subscribeByEventName < T >(eventName: string, subscriberId: string, callback: IEventCallback<T>): void;
  subscribeBySourceId < T >(sourceId: string, subscriberId: string, callback: IEventCallback<T>): void;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
interface IEventCallback<T> {
  // (undocumented)
  (eventName: string, eventObject: IEvent<T>): void;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal (undocumented)
interface IInternalWebPartData extends IWebPartData {
  // @deprecated
  htmlProperties?: string;
}

// @public
interface IPlaceholderSpinnerProps {
  hideSpinner?: boolean;
  label: string;
}

// @public
interface IPropertyPaneAccessor {
  isPropertyPaneOpen(): boolean;
  isRenderedByWebPart(): boolean;
  open(): void;
  refresh(): void;
}

// @public
interface IPropertyPaneButtonProps {
  ariaDescription?: string;
  ariaLabel?: string;
  buttonType?: PropertyPaneButtonType;
  description?: string;
  disabled?: boolean;
  icon?: string;
  onClick: (value: any) => any;
  text: string;
}

// @public
interface IPropertyPaneCheckboxProps {
  checked?: boolean;
  disabled?: boolean;
  text?: string;
}

// @public
interface IPropertyPaneChoiceGroupOption {
  checked?: boolean;
  disabled?: boolean;
  iconProps?: IPropertyPaneChoiceGroupOptionIconProps;
  imageSize?: {
    height: number;
    width: number;
  }
  imageSrc?: string;
  key: string | number;
  selectedImageSrc?: string;
  text: string;
}

// @public
interface IPropertyPaneChoiceGroupOptionIconProps {
  officeFabricIconFontName?: string | null;
}

// @public
interface IPropertyPaneChoiceGroupProps {
  label?: string;
  options: IPropertyPaneChoiceGroupOption[];
}

// @public
interface IPropertyPaneConfiguration {
  currentPage?: number;
  loadingIndicatorDelayTime?: number;
  pages: IPropertyPanePage[];
  showLoadingIndicator?: boolean;
}

// @public
interface IPropertyPaneCustomFieldProps {
  context?: any;
  key: string;
  onDispose?: (domElement: HTMLElement, context?: any) => void;
  onRender: (
      domElement: HTMLElement,
      context?: any,
      changeCallback?: (targetProperty?: string, newValue?: any) => void) => void;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
interface IPropertyPaneData {
  configuration: IPropertyPaneConfiguration;
  isReactive?: boolean;
  onConfigurationEvent: (eventType: WebPartConfigurationEvent) => void;
  onPropertyPaneFieldChanged: (propertyName: string, newValue: any) => void;
  onRendered: () => void;
  properties: any;
  render?: () => void;
  shouldResetState?: boolean;
  title: string;
  webPartId: string;
}

// @public
interface IPropertyPaneDropdownOption {
  index?: number;
  key: string | number;
  text: string;
  type?: PropertyPaneDropdownOptionType;
}

// @public
interface IPropertyPaneDropdownProps {
  ariaLabel?: string;
  disabled?: boolean;
  label: string;
  options?: IPropertyPaneDropdownOption[];
  selectedKey?: string | number;
}

// @public
interface IPropertyPaneField<TProperties> {
  properties: TProperties;
  shouldFocus?: boolean;
  targetProperty: string;
  type: PropertyPaneFieldType;
}

// @public
interface IPropertyPaneGroup {
  groupFields: IPropertyPaneField<any>[];
  groupName?: string;
  isCollapsed?: boolean;
}

// @public
interface IPropertyPaneLabelProps {
  required?: boolean;
  text: string;
}

// @public
interface IPropertyPaneLinkProps {
  disabled?: boolean;
  href: string;
  popupWindowProps?: IPopupWindowProps;
  target?: string;
  text: string;
}

// @public
interface IPropertyPanePage {
  displayGroupsAsAccordion?: boolean;
  groups: IPropertyPaneGroup[];
  header?: IPropertyPanePageHeader;
}

// @public
interface IPropertyPanePageHeader {
  description: string;
  image?: string;
}

// @public
interface IPropertyPaneSliderProps {
  ariaLabel?: string;
  disabled?: boolean;
  label?: string;
  max: number;
  min: number;
  showValue?: boolean;
  step?: number;
  value?: number;
}

// @public
interface IPropertyPaneTextFieldProps {
  ariaLabel?: string;
  deferredValidationTime?: number;
  description?: string;
  disabled?: boolean;
  errorMessage?: string;
  label?: string;
  maxLength?: number;
  multiline?: boolean;
  onGetErrorMessage?: (value: string) => string | Promise<string>;
  placeholder?: string;
  resizable?: boolean;
  rows?: number;
  underlined?: boolean;
  validateOnFocusIn?: boolean;
  validateOnFocusOut?: boolean;
  value?: string;
}

// @public
interface IPropertyPaneToggleProps {
  checked?: boolean;
  disabled?: boolean;
  key?: string | number;
  label: string;
  offAriaLabel?: string;
  offText?: string;
  onAriaLabel?: string;
  onText?: string;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
interface IReactWebPartProps extends IWebPartProps {
  mode: DisplayMode;
}

// @public
interface ISerializedServerProcessedData {
  htmlStrings?: {
    [ key: string ]: string
  }
  imageSources?: {
    [ key: string ]: string
  }
  links?: {
    [ key: string ]: string
  }
  searchablePlainTexts?: {
    [ key: string ]: string
  }
}

// @public
interface ISerializedWebPartData {
  dataVersion: Version;
  properties?: any;
  serverProcessedContent?: ISerializedServerProcessedData;
}

// @alpha
interface IWebPartConfigurationEventCallback {
  // (undocumented)
  (event: WebPartConfigurationEvent, data?: any): void;
}

// @public @deprecated
interface IWebPartContext {
  domElement: HTMLElement;
  // @alpha
  eventAggregator: IEventAggregator;
  // @beta
  graphHttpClient: GraphHttpClient;
  // @alpha
  host: IWebPartHost;
  httpClient: HttpClient;
  instanceId: string;
  manifest: IClientSideWebPartManifestInstance<any>;
  pageContext: PageContext;
  propertyPane: IPropertyPaneAccessor;
  spHttpClient: SPHttpClient;
  statusRenderer: IClientSideWebPartStatusRenderer;
  webPartTag: string;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
interface IWebPartContextParameters extends _IComponentContextParameters {
  domElement: HTMLElement;
  // @alpha
  eventAggregator: IEventAggregator;
  // @alpha
  host: IWebPartHost;
  instanceId: string;
  isPropertyPaneOpen: () => boolean;
  isPropertyPaneRenderedByWebPart: () => boolean;
  manifest: IClientSideWebPartManifestInstance<any>;
  setPropertyPaneState: (
        id: string,
        propertyPaneState?: PropertyPaneState,
        renderedByWebPart?: boolean) => void;
  statusRenderer: IClientSideWebPartStatusRenderer;
  webPartTag: string;
}

// @public
interface IWebPartData {
  dataVersion: string;
  description?: string;
  id: string;
  instanceId: string;
  properties?: any;
  serverProcessedContent?: ISerializedServerProcessedData;
  title: string;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
interface IWebPartEvent<T> extends IEvent<T> {
  source: string;
  target: string;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
interface IWebPartFormProps extends React.HTMLProps<HTMLElement> {
  // (undocumented)
  isClassicSharePointPage: boolean;
}

// @alpha
interface IWebPartHost {
  isViewportLoadingDisabled?: boolean;
  serviceScope: ServiceScope;
  setDirty?: (instanceId: string, data?: any) => void;
  webPartConfigurationEventCallback?: IWebPartConfigurationEventCallback;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
interface IWebPartManagerContext {
  addedFromPersistedData?: boolean;
  displayMode: DisplayMode;
  domElement: HTMLElement;
  host?: IWebPartHost;
  instanceId: string;
  manifest: IClientSideWebPartManifest<any>;
  onViewportWebPartsRendered?: (endTime: number) => void;
  scrollableParent?: HTMLElement;
  totalWebparts?: number;
  webPartData?: IWebPartData;
}

// @public
interface IWebPartPropertiesMetadata {
  // WARNING: The type "IWebPartPropertyMetadata" needs to be exported by the package (e.g. added to index.ts)
  // (undocumented)
  [ key: string ]: IWebPartPropertyMetadata;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
class PlaceholderSpinner extends React.Component<IPlaceholderSpinnerProps, IPlaceholderSpinnerState> {
  public constructor(props: IPlaceholderSpinnerProps);
  public clearPlaceholder(): void;
  // (undocumented)
  public componentDidMount(): void;
  // (undocumented)
  public componentWillUnmount(): void;
  public render(): React.ReactElement<IPlaceholderSpinnerProps>;
  // (undocumented)
  public showSpinner(showSpinner: boolean): void;
}

// @public
export function PropertyPaneButton(targetProperty: string,
  properties: IPropertyPaneButtonProps): IPropertyPaneField<IPropertyPaneButtonProps>;

// @public
enum PropertyPaneButtonType {
  Command,
  Compound,
  Hero,
  Icon,
  Normal,
  Primary
}

// @public
export function PropertyPaneCheckbox(targetProperty: string,
  properties: IPropertyPaneCheckboxProps): IPropertyPaneField<IPropertyPaneCheckboxProps>;

// @public
export function PropertyPaneChoiceGroup(targetProperty: string,
  properties: IPropertyPaneChoiceGroupProps): IPropertyPaneField<IPropertyPaneChoiceGroupProps>;

// @beta
export function PropertyPaneCustomField(properties: IPropertyPaneCustomFieldProps): IPropertyPaneField<IPropertyPaneCustomFieldProps>;

// @public
export function PropertyPaneDropdown(targetProperty: string,
  properties: IPropertyPaneDropdownProps): IPropertyPaneField<IPropertyPaneDropdownProps>;

// @public
enum PropertyPaneDropdownOptionType {
  Divider = 1,
  Header = 2,
  Normal = 0
}

// @public
enum PropertyPaneFieldType {
  Button = 11,
  CheckBox = 2,
  ChoiceGroup = 10,
  Custom = 1,
  Dropdown = 6,
  Heading = 9,
  HorizontalRule = 12,
  Label = 7,
  Link = 13,
  Slider = 8,
  TextField = 3,
  Toggle = 5
}

// @public
export function PropertyPaneHorizontalRule(): IPropertyPaneField<void>;

// @public
export function PropertyPaneLabel(targetProperty: string,
  properties: IPropertyPaneLabelProps): IPropertyPaneField<IPropertyPaneLabelProps>;

// @public
export function PropertyPaneLink(targetProperty: string,
  properties: IPropertyPaneLinkProps): IPropertyPaneField<IPropertyPaneLinkProps>;

// @public
export function PropertyPaneSlider(targetProperty: string,
  properties: IPropertyPaneSliderProps): IPropertyPaneField<IPropertyPaneSliderProps>;

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
enum PropertyPaneState {
  // (undocumented)
  Close = 2,
  // (undocumented)
  Default = 4,
  // (undocumented)
  Open = 1,
  Refresh = 5,
  // (undocumented)
  Toggle = 3
}

// @public
export function PropertyPaneTextField(targetProperty: string,
  properties: IPropertyPaneTextFieldProps): IPropertyPaneField<IPropertyPaneTextFieldProps>;

// @public
export function PropertyPaneToggle(targetProperty: string,
  properties: IPropertyPaneToggleProps): IPropertyPaneField<IPropertyPaneToggleProps>;

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
class ReactWebPart<TProperties> extends BaseClientSideWebPart<TProperties> {
  constructor(componentType: React.ComponentClass<IReactWebPartProps>);
  // (undocumented)
  protected onDispose(): void;
  // (undocumented)
  public render(): void;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
class ReservedEventNames {
  // (undocumented)
  public static classicToolpane: string;
  // (undocumented)
  public static classicToolpaneId: string;
  // (undocumented)
  public static configure: string;
  // (undocumented)
  public static configureEnd: string;
  // (undocumented)
  public static configureStart: string;
  // (undocumented)
  public static delimitor: string;
  // (undocumented)
  public static end: string;
  // (undocumented)
  public static start: string;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
enum WebPartConfigurationEvent {
  PropertyPaneApplyClicked = 5,
  PropertyPaneClosed = 4,
  PropertyPaneConfigurationComplete = 2,
  PropertyPaneConfigurationStart = 1,
  PropertyPaneLostFocus = 6,
  PropertyPaneOpened = 3,
  PropertyPaneWebPartsSwitched = 7
}

// @beta
class WebPartContext extends BaseComponentContext {
  constructor(parameters: IWebPartContextParameters);
  public readonly domElement: HTMLElement;
  // @alpha
  public readonly eventAggregator: IEventAggregator;
  // @beta
  public readonly graphHttpClient: GraphHttpClient;
  // @alpha
  public readonly host: IWebPartHost;
  public readonly httpClient: HttpClient;
  public manifest: IClientSideWebPartManifestInstance<any>;
  public readonly propertyPane: IPropertyPaneAccessor;
  public readonly spHttpClient: SPHttpClient;
  public readonly statusRenderer: IClientSideWebPartStatusRenderer;
  public readonly webPartTag: string;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
class WebPartDataConverter {
  public static convertHtmlToWebPartData(htmlString: string, links?: string[]): IWebPartData | undefined;
  public static convertServerProcessedDataToHtml(serverContent: ISerializedServerProcessedData | undefined): string;
  public static convertServerProcessedHtmlToData(htmlString: string, links?: string[]): ISerializedServerProcessedData;
  public static convertWebPartDataToHtml(webpartData: IWebPartData): string;
  public static isWebPartHtml(htmlString: string): boolean;
}

// WARNING: Because this definition is explicitly marked as @internal, an underscore prefix ("_") should be added to its name
// @internal
class WebPartForm extends React.Component<IWebPartFormProps, {}> {
  constructor(props: IWebPartFormProps);
  // (undocumented)
  public render(): JSX.Element;
}

