$currentDir = $(get-location).Path
$desktopPath = ([Environment]::GetFolderPath("Desktop"))
$shortcutName = ("sp-client [{0}]" -f ($currentDir.Replace(":\", "-").Replace("\", "-")))
$shortcutPath = Join-Path $desktopPath ($shortcutName + ".lnk")

$shortcut = (New-Object -ComObject WScript.Shell).CreateShortcut($shortcutPath)
$shortcut.TargetPath = Join-Path $currentDir "CommandPrompt-Cmd.cmd"
$shortcut.IconLocation = Join-Path $currentDir "common\docs\Images\sp-client.ico"
$shortcut.Description = "Command Prompt with environment configured for working on sp-client"
$shortcut.WorkingDirectory = $currentDir
$shortcut.Save()

# This is a hack to mark the shortcut for "Run As Administrator",
# since the official IShellLinkDataList is awkward to use.
$code = @"
using System.IO;
namespace SpClient
{
    public static class ShortcutHelper
    {
        public static void MarkRunAsAdmin(string shortcutPath)
        {
            using (FileStream fs = new FileStream(shortcutPath, FileMode.Open, FileAccess.ReadWrite))
            {
                fs.Seek(21, SeekOrigin.Begin);
                fs.WriteByte(0x22);
            }
        }
    }
}
"@
Add-Type -TypeDefinition $code -Language CSharp
[SpClient.ShortcutHelper]::MarkRunAsAdmin($shortcutPath)
    
Write-Host ""
Write-Host "The shortcut `"$shortcutName`" was created on your desktop."
Write-Host "It will run `"CommandPrompt-Cmd.cmd`" as Administrator from the"
Write-Host -NoNewline "folder `"$currentDir`".  [ENTER] "

$host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown") | out-null
