/**
 * @file IBaseCollectionWebPartViewProperties.ts
 * @Copyright (c) Microsoft Corporation.  All rights reserved.
 */

import { DisplayMode } from '@microsoft/sp-core-library';
import { IBaseProps } from 'office-ui-fabric-react';

import { IDataRow } from '@ms/sp-component-utilities';
import DisplayFieldMap from '../../displayFieldMap/DisplayFieldMap';
import { IBaseCollectionWebPartOptions } from './IBaseCollectionWebPartOptions';
import { IBaseCollectionWebPartProperties } from './IBaseCollectionWebPartProperties';
import { ILayoutInfo } from './ILayoutInfo';

export interface IBaseCollectionWebPartViewProperties
  extends IBaseCollectionWebPartProperties, IBaseCollectionWebPartOptions, IBaseProps {

  displayMode?: DisplayMode;
  errorCallback?: (error: Error) => void;
  renderedOnce?: boolean;
  defaultTitle?: string;
  layoutInfo?: ILayoutInfo;
  items?: IDataRow[];
  displayFieldMap?: DisplayFieldMap;
  hasInitialLoadingState?: boolean;
  width?: number;
}
