/**
 * @file CalculatedField.ts
 * @copyright Microsoft Corporation. All rights reserved.
 */

import * as React from 'react';
import { IDataRow } from '@ms/sp-component-utilities';
import { IDisplayField } from './models/IDisplayField';
import MappedField from './MappedField';

export default class CalculatedField extends MappedField {
  private _formatter: (row: IDataRow) => Object;

  constructor(
    target: string,
    displayField: IDisplayField,
    formatter: (row: IDataRow) => Object,
    onRenderCell?: (item?: IDataRow, index?: number) => React.ReactNode) {

    super(target, displayField, onRenderCell);
    this._formatter = formatter;
  }

  public get formatter(): (row: IDataRow) => Object {
    return this._formatter;
  }
}