/**
 * @copyright Microsoft Corporation. All rights reserved.
 * @file ILazyLoaderProps.ts
 */

import * as React from 'react';

export interface ISPLazyLoaderProps {
  /**
   * Placeholder to be randered immediately for lazy loaded components
   */
  placeholder?: React.ReactElement<any>; // tslint:disable-line:no-any

  /**
   * Height of the component to be rendered. Optional if placeholder provided
   */
  height?: number;

  /**
   * The offset from the viewport when component should be rendered
   */
  offset?: number;

  /**
   * Optional callback function when Lazy component is rendered
   */
  onRendered?: () => void;
}