/// <reference types="mocha" />
/// <reference types="sinon" />
declare var sinon: sinon.SinonStatic;
/* tslint:disable:no-any */
/* tslint:disable:no-empty */

import * as React from 'react';
import { shallow, ShallowWrapper } from 'enzyme';
import SlideChangeButton, { ISlideChangeButtonProps, ButtonDirection } from '../SlideChangeButton';
import { expect } from 'chai';

/* tslint:disable:no-unused-expression */

describe('Slide change button tests', () => {
  let clickSpy: sinon.SinonSpy;
  const mockProps: ISlideChangeButtonProps = {
    onClick: (): boolean => { return false; },
    shouldFocus: true,
    offsetPixels: 10,
    buttonDirection: ButtonDirection.Next
  };

  it('should trigger the click event when clicked', () => {
    clickSpy = sinon.spy((): void => { });
    mockProps.onClick = clickSpy;
    const button: ShallowWrapper<ISlideChangeButtonProps, {}> =
      shallow<ISlideChangeButtonProps, {}>(React.createElement(SlideChangeButton, mockProps));
    button.find(`[data-automation-id='next-button']`).simulate('click');
    expect(clickSpy.called).to.be.true;
  });

  it('should render prev button to the left', () => {
    mockProps.buttonDirection = ButtonDirection.Prev;
    const button: ShallowWrapper<ISlideChangeButtonProps, {}> =
      shallow<ISlideChangeButtonProps, {}>(React.createElement(SlideChangeButton, mockProps));
    expect(button.find(`[data-automation-id='prev-button']`).html()).to.contain('left');
  });
});
