/**
 * Props for component used to display the error placeholder in case of OAuth Error.
 *
 * @public
 */
import {
  OAuthUtilityError
} from '@ms/sp-client-shared';

export interface IOAuthErrorRendererProps {
  /**
   * Full Error from token auth
   */
  error: OAuthUtilityError;

  /**
   * Icon of webpart to show in the placeholder
   */
  webpartIcon: string;

  /**
   * Name of webpart to show under the webpart icon
   */
  webpartName: string;

  /**
   * Alias of the webpart for diagnostics
   */
  webpartAlias: string;

  /**
   * Optional override of the error message to be displayed
   */
  customErrorMessage?: string;

  /**
   * Optional CSS class name for the root element of content. Use this to
   * apply custom styles to the placeholder.
   */
  contentClassName?: string;
}
