/**
 * @file SetUtilities.ts
 * @Copyright (c) Microsoft Corporation.  All rights reserved.
 */

import * as lodash from '@microsoft/sp-lodash-subset';

export default class SetUtilities {
  // tslint:disable:no-any
  public static union(setA: Set<any>, setB: Set<any>): Set<any> {
    if (!setA && !setB) {
      return new Set<any>();
    }

    const setAclone: Set<any> = setA ? lodash.clone(setA) : new Set<any>();
    const setBclone: Set<any> = setB ? lodash.clone(setB) : new Set<any>();

    let union: Set<any>;
    if (setAclone.size > setBclone.size) {
      union = setAclone;
      setBclone.forEach((x: any) => { union.add(x); });
    } else {
      union = setBclone;
      setAclone.forEach((x: any) => { union.add(x); });
    }

    return union;
  } // tslint:enable:no-any
}