# Change Log - @microsoft/sp-build-core-tasks

This log was last generated on Fri, 22 Sep 2017 21:14:03 GMT and should not be manually modified.

## 1.3.0
Fri, 22 Sep 2017 20:19:09 GMT

### Patches

- Package-solution now displays a warning when attempting to package Extensions if the SkipFeatureDeployment flag is activated. Additionally, package-solution will error when attempting to use custom Feature XML or Custom Assets if the SkipFeatureDeployment flag is activated.
- Update schemas to allow for the $schema field
- Fix an issue with package-solution where attempting to write the SPPKG to a subfolder caused an exception to be thrown
- add BUILD_NUMBER webpack defined variable

## 1.2.0
Fri, 25 Aug 2017 20:31:17 GMT

### Minor changes

- Update the build tasks to support config.json version 2.0
- Allow gulp serve to support multiple configurations
- Upgrade to TypeScript 2.4
- Support bundling multiple components into a single file
- Add support for bundling Library components into an SPPKG
- Use lockstep version for all SPFx packages

### Patches

- Add support for upgrading config.json files from version 1.0 to version 2.0
- Allow dev-deploy to retry uploads three times before failing to account for flaky or slow connections
- Fix a bug in the solution packaging code
- Include warnings when a project without any bundles is being built
- Allow projects uploaded via dev-deploy to not be isolated
- Make loader-load-themed-styles call loadStyles with "async" set to "true."
- Support localization of the "title" and "ariaLabel" fields in the command set manifest
- Move the config.json parsing out of sp-build-common into sp-build-core-tasks.
- Allow bundle names to be up to 64 characters in length
- Add deprecation notice for "safeWithCustomScriptDisabled" manifest property and ignore it during packaging.
- Fix an issue in dev-deploy where we would attempt to upload directories with periods in their names as files

## 1.1.2
Tue, 11 Jul 2017 18:54:39 GMT

### Patches

- Fixed an issue with "gulp package-solution" where it was not respecting the safeWithCustomScriptDisabled flag.
- Add the SkipFeatureDeployment flag to 'package-solution', allowing the tenant admin to skip feature or site deployment

## 1.1.1
Thu, 08 Jun 2017 19:39:03 GMT

### Patches

- Fixed an issue with "gulp package-solution" where the safeWithCustomScriptDisabled  manifest property was being ignored.

## 1.1.0
Thu, 25 May 2017 21:09:42 GMT

### Minor changes

- During dev-deploy, allow the user to specify a test page using the  dev_deploy_url environment variable. The task will then print a full URL, which helps reduce the need for manual string manipulation during testing
- Updated manifest processing to support "version": "*" to automatically get the version from the package.json. All other cases now leave the manifest unmodified
- Updated the webpack visualization plugin to use webpack-bundle-analyzer
- Upgraded to Webpack 2.0
- Added IConfigEntry
- Updated to TypeScript 2.2
- Added an --entry flag, which limits the webpack task to only bundling certain entries, which can be specified using their alias or id
- Removed "shouldWrapProductionManifestForManifestServer" config property from the write-manifests task
- Added the ability to exclude filename hashes for the CopyAssets task
- Ensured the "*" version is replaced with the real version in the produced JS file
- Fixed an issue where globs wouldn't work correctly when running in Docker
- Fixed a minor issue where localized paths in debug manifests produced in --ship mode are missing a default entry
- Allowed manifest JSON files to have comments
- Ensured that multiple config.json entries don't point to the same input or output filenames
- Included CSS as a default extension that's automatically copied from src to lib
- Allowed the webpack stats data files to be dropped in a location in addition to temp/stats
- Debug manifests should respect debugLocale in manifest's localized strings
- Lock loader-utils version, as newer version shows deprecation warnings when using css-loader

## 1.0.1
Thu, 23 Mar 2017 22:48:10 GMT

### Patches

- Ensuring that react and react-dom get the correct version in manifests and ensuring that office-ui-fabric-react can be statically bundled
- Updating the version of office-ui-fabric-react
- Bugfix: on Windows, certain relationships files contained backslashes

## 1.0.0
Fri, 17 Feb 2017 23:09:23 GMT

### Breaking changes

- General availability

### Minor changes

- Added support for loading custom sharepoint assets (such as element file, element manifest, and upgrade action) into the package-solution task
- Updated to TypeScript 2.1

### Patches

- Set the correct package name in the "define" statement at the top of an AMD bundle when a project contains multiple entrypoints
- Included "shallowDiscoverProperty" helper function for populating localized strings in manifests
- Upgraded React to 15.4.1
- Locked version numbers for @types packages
- Updated .npmignore
- Introduced --rush option in dev-deploy to deploy an entire rush repo
- Included the module version in the webpack JSONP function name and in the component name
- Logging the issuer of a module that should not be bundled
- Updated version numbers for consistency
- Moved schema files next to the appropriate task
- Created the WebPack .stats.json and .stats.html in the temp/stats/ folder

## 0.7.0
Tue, 03 Jan 2017 21:52:49 GMT

### Minor changes

- More changes for RC0 release

## 0.6.0
Tue, 06 Dec 2016 20:44:26 GMT

### Minor changes

- Changes for RC0 release

## 0.5.1

### Minor changes

- Renamed .spapp extension to .sppkg on package-solution task
- Including new, secondary webpack configuration task to bundle localized resources

### Patches

- Fixing a bug where the second webpack task would fail during `gulp serve` after a change is made

## 0.4.0

### Minor changes

- undefined
- undefined
- undefined
- undefined

### Patches

- undefined

## 0.3.0

*Changes not tracked*

## 0.2.1

### Patches

- Removed a couple of superfluous references to `es6-promise`
- Refactor cumulative manifest processing code to fix a couple of issues and make the manifest discovery process more flexible
- Refactor of the upload-CDN task code to fix a couple of minor issues and improve readability
- Removing superfluous dependency on `globalize`

## 0.2.0

*Changes not tracked*

## 0.1.26

*Initial release*

