using System;
using System.Windows.Forms;

namespace SifterKit.Controls
{
    /// <summary>
    /// <see cref="ListViewEx"/> extends the <see cref="ListView"/> control by enabling double-buffered
    /// rendering to reduce flickering when drawing large numbers of items.
    /// </summary>
    /// <owner alias="PGonzal" />
    // http://www.xtremevbtalk.com/showthread.php?t=305330
    public class ListViewEx : ListView
    {
        public ListViewEx()
        {
            SetStyle(ControlStyles.OptimizedDoubleBuffer
                | ControlStyles.AllPaintingInWmPaint
                | ControlStyles.EnableNotifyMessage, true);
        }

        protected override void OnNotifyMessage(Message m)
        {
            if (m.Msg == 20) return;
            base.OnNotifyMessage(m);
        }
    }
}
