// Type definitions for entities 1.1.1
// Definitions by: nickpape

interface encoder {
  (text: string): string
}

interface decoder {
  (text: string): string
}

declare module "entities" {

  interface IEntities {
    encode: (data: string, level: number) => string;
    decode: (data: string, level: number) => string;
    decodeStrict: (data: string, level: number) => string;

    encodeXML: encoder;

    encodeHTML: encoder;
    encodeHTML4: encoder;
    encodeHTML5: encoder;

    decodeXML: decoder;
    decodeXMLStrict: encoder;

    decodeHTML4 : encoder;
    decodeHTML5 : encoder;
    decodeHTML : encoder;

    decodeHTML4Strict : encoder;
    decodeHTML5Strict : encoder;
    decodeHTMLStrict : encoder;

    escape: encoder;
  }

  const entities: IEntities;
  export = entities;
}
