declare namespace Parser {
  interface ILine {
    type: string;
    break: boolean;
    text: string;
    ln1: number;
    ln2: number;
  }

  interface IFile {
    deleted: boolean;
    added: boolean;
    renamed: boolean;
    binary: boolean;
    lines: ILine[];
    index: string[];
    name: string;
    oldName: string;
  }

  interface ICommit {
    sha: string;
    author: string;
    email: string;
    files: IFile[];
  }

  interface IDiff {
    detailed: boolean;
    commits: ICommit[];
  }

  interface IParser {
    new (buffer: Buffer): Parser.IDiff;
  }

  interface INewLineDiff {
    [fileName: string]: string[];
  }
}

declare module "git-diff-parser" {
  var Parser: Parser.IParser;
  export = Parser;
}
