# VSTS-Deploy

This project is used by our CI system to continuously deploy master to our CDNs and manifest service.

This project currently relies on the OneDrive-BuildToools, so it relies on Bower.

Everything in the app-min directory in this project is uploaded to the CDN, and JSON files that match project names in sources.json are uploaded to the manifest server.

## Running this project

1. `bower install`
2. `npm install`
3. Clone the deploy scripts with `git clone https://onedrive.visualstudio.com/DefaultCollection/OneDriveWeb/_git/deploy-server _Deploy 2>&1`
4. Deploy files to the CDN with `_Deploy\Deploy\DeployFiles.ps1 $(StorageAccount) $(SubscriptionID) $(StorageType) "$(Locations)" $(SCRAMCertName) $(BranchType) "$(Build.BuildNumber)" $(Environments)`
5. Deploy files to the manifest server with `_Deploy\Deploy\DeployManifests.ps1 $(StorageAccount) $(SubscriptionID) $(StorageType) "$(Locations)" $(SCRAMCertName) $(BranchType) "$(Build.BuildNumber)"`

## Cleaning up

`_Deploy` must be deleted between CI runs in order to prevent an error. `app` and `app-min` should be deleted to prevent assets from being uploaded to the CDNs multiple times. For the cleanest build, delete `npm_install` and `bower_install`.
